diff --git a/testing/mozbase/mozlog/mozlog/unstructured/loggingmixin.py b/testing/mozbase/mozlog/mozlog/unstructured/loggingmixin.py
index 41a67cf09e..5700af1000 100644
--- a/testing/mozbase/mozlog/mozlog/unstructured/loggingmixin.py
+++ b/testing/mozbase/mozlog/mozlog/unstructured/loggingmixin.py
@@ -8,7 +8,7 @@ from .logger import (
 )
 
 
-class LoggingMixin(object):
+class LoggingMixin:
     """Expose a subset of logging functions to an inheriting class."""
 
     def set_logger(self, logger_instance=None, name=None):
diff --git a/testing/mozbase/mozlog/mozlog/unstructured/loglistener.py b/testing/mozbase/mozlog/mozlog/unstructured/loglistener.py
index d567301805..77d08f1ed9 100644
--- a/testing/mozbase/mozlog/mozlog/unstructured/loglistener.py
+++ b/testing/mozbase/mozlog/mozlog/unstructured/loglistener.py
@@ -2,21 +2,21 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-import SocketServer
+import socketserver
 import socket
 import json
 
 
-class LogMessageServer(SocketServer.TCPServer):
+class LogMessageServer(socketserver.TCPServer):
 
     def __init__(self, server_address, logger, message_callback=None, timeout=3):
-        SocketServer.TCPServer.__init__(self, server_address, LogMessageHandler)
+        socketserver.TCPServer.__init__(self, server_address, LogMessageHandler)
         self._logger = logger
         self._message_callback = message_callback
         self.timeout = timeout
 
 
-class LogMessageHandler(SocketServer.BaseRequestHandler):
+class LogMessageHandler(socketserver.BaseRequestHandler):
     """Processes output from a connected log source, logging to an
     existing logger upon receipt of a well-formed log messsage."""
 
diff --git a/testing/mozbase/mozlog/tests/test_logger.py b/testing/mozbase/mozlog/tests/test_logger.py
index 30f4eb5699..ea35624959 100644
--- a/testing/mozbase/mozlog/tests/test_logger.py
+++ b/testing/mozbase/mozlog/tests/test_logger.py
@@ -80,7 +80,7 @@ class TestStructuredLogging(unittest.TestCase):
         The actual message should contain no fields other than the timestamp
         field and those present in expected."""
 
-        self.assertTrue(isinstance(actual['_time'], (int, long)))
+        self.assertTrue(isinstance(actual['_time'], int))
 
         for k, v in expected.items():
             self.assertEqual(v, actual[k])
diff --git a/testing/mozbase/mozlog/tests/test_structured.py b/testing/mozbase/mozlog/tests/test_structured.py
index ab4b5f5826..a7b621ca7a 100644
--- a/testing/mozbase/mozlog/tests/test_structured.py
+++ b/testing/mozbase/mozlog/tests/test_structured.py
@@ -1,4 +1,3 @@
-# -*- coding: utf-8 -*-
 import argparse
 import json
 import optparse
@@ -19,9 +18,11 @@ from mozlog import (
     handlers,
     formatters,
 )
+import six
+unichr = chr
 
 
-class TestHandler(object):
+class TestHandler:
 
     def __init__(self):
         self.items = []
@@ -55,20 +56,20 @@ class BaseStructuredTest(unittest.TestCase):
         all_expected = {"pid": os.getpid(),
                         "thread": "MainThread",
                         "source": "test"}
-        specials = set(["time"])
+        specials = {"time"}
 
         all_expected.update(expected)
-        for key, value in all_expected.iteritems():
+        for key, value in all_expected.items():
             self.assertEqual(actual[key], value)
 
-        self.assertEquals(set(all_expected.keys()) |
+        self.assertEqual(set(all_expected.keys()) |
                           specials, set(actual.keys()))
 
 
 class TestStatusHandler(BaseStructuredTest):
 
     def setUp(self):
-        super(TestStatusHandler, self).setUp()
+        super().setUp()
         self.handler = handlers.StatusHandler()
         self.logger.add_handler(self.handler)
 
@@ -253,8 +254,8 @@ class TestStructuredLog(BaseStructuredTest):
                                 "test": "test2"})
         self.logger.test_end("test2", "PASS", expected="PASS")
         last_item = self.pop_last_item()
-        self.assertEquals(last_item["action"], "log")
-        self.assertEquals(last_item["level"], "ERROR")
+        self.assertEqual(last_item["action"], "log")
+        self.assertEqual(last_item["level"], "ERROR")
         self.assertTrue(last_item["message"].startswith(
             "test_end for test2 logged while not in progress. Logged with data: {"))
         self.logger.suite_end()
@@ -265,8 +266,8 @@ class TestStructuredLog(BaseStructuredTest):
                                 "tests": []})
         self.logger.suite_start([])
         last_item = self.pop_last_item()
-        self.assertEquals(last_item["action"], "log")
-        self.assertEquals(last_item["level"], "ERROR")
+        self.assertEqual(last_item["action"], "log")
+        self.assertEqual(last_item["level"], "ERROR")
         self.logger.suite_end()
 
     def test_suite_end_no_start(self):
@@ -277,16 +278,16 @@ class TestStructuredLog(BaseStructuredTest):
         self.assert_log_equals({"action": "suite_end"})
         self.logger.suite_end()
         last_item = self.pop_last_item()
-        self.assertEquals(last_item["action"], "log")
-        self.assertEquals(last_item["level"], "ERROR")
+        self.assertEqual(last_item["action"], "log")
+        self.assertEqual(last_item["level"], "ERROR")
 
     def test_multiple_loggers_suite_start(self):
         logger1 = structuredlog.StructuredLogger("test")
         self.logger.suite_start([])
         logger1.suite_start([])
         last_item = self.pop_last_item()
-        self.assertEquals(last_item["action"], "log")
-        self.assertEquals(last_item["level"], "ERROR")
+        self.assertEqual(last_item["action"], "log")
+        self.assertEqual(last_item["level"], "ERROR")
 
     def test_multiple_loggers_test_start(self):
         logger1 = structuredlog.StructuredLogger("test")
@@ -294,8 +295,8 @@ class TestStructuredLog(BaseStructuredTest):
         self.logger.test_start("test")
         logger1.test_start("test")
         last_item = self.pop_last_item()
-        self.assertEquals(last_item["action"], "log")
-        self.assertEquals(last_item["level"], "ERROR")
+        self.assertEqual(last_item["action"], "log")
+        self.assertEqual(last_item["level"], "ERROR")
 
     def test_process(self):
         self.logger.process_output(1234, "test output")
@@ -407,10 +408,10 @@ class TestTypeConversions(BaseStructuredTest):
     def test_tuple(self):
         self.logger.suite_start([])
         self.logger.test_start(("\xf0\x90\x8d\x84\xf0\x90\x8c\xb4\xf0\x90\x8d\x83\xf0\x90\x8d\x84",
-                                42, u"\u16a4"))
+                                42, "\u16a4"))
         self.assert_log_equals({"action": "test_start",
-                                "test": (u'\U00010344\U00010334\U00010343\U00010344',
-                                         u"42", u"\u16a4")})
+                                "test": ('\U00010344\U00010334\U00010343\U00010344',
+                                         "42", "\u16a4")})
         self.logger.suite_end()
 
     def test_non_string_messages(self):
@@ -434,7 +435,7 @@ class TestTypeConversions(BaseStructuredTest):
             self.logger.info("☺")
             logfile.seek(0)
             data = logfile.readlines()[-1].strip()
-            self.assertEquals(data, "☺")
+            self.assertEqual(data, "☺")
             self.logger.suite_end()
 
     def test_arguments(self):
@@ -784,7 +785,7 @@ class TestXUnitFormatter(FormatterTest):
         self.logger.suite_end()
 
         root = self.log_as_xml()
-        self.assertEquals('Expected OK, got FAIL', root.find(
+        self.assertEqual('Expected OK, got FAIL', root.find(
             'testcase/failure').get('message'))
 
     def test_suite_attrs(self):
@@ -858,7 +859,7 @@ class TestCommandline(unittest.TestCase):
     def test_setup_logging_optparse_unicode(self):
         parser = optparse.OptionParser()
         commandline.add_logging_group(parser)
-        args, _ = parser.parse_args([u"--log-raw=-"])
+        args, _ = parser.parse_args(["--log-raw=-"])
         logger = commandline.setup_logging("test_optparse_unicode", args, {})
         self.assertEqual(len(logger.handlers), 1)
         self.assertEqual(logger.handlers[0].stream, sys.stdout)
@@ -924,13 +925,13 @@ class TestBuffer(BaseStructuredTest):
         all_expected = {"pid": os.getpid(),
                         "thread": "MainThread",
                         "source": "testBuffer"}
-        specials = set(["time"])
+        specials = {"time"}
 
         all_expected.update(expected)
-        for key, value in all_expected.iteritems():
+        for key, value in all_expected.items():
             self.assertEqual(actual[key], value)
 
-        self.assertEquals(set(all_expected.keys()) |
+        self.assertEqual(set(all_expected.keys()) |
                           specials, set(actual.keys()))
 
     def setUp(self):
@@ -985,11 +986,11 @@ class TestBuffer(BaseStructuredTest):
                                 "test": "test1"})
 
         # The buffer's actual size never grows beyond the specified limit.
-        self.assertEquals(len(self.handler._buffer), 4)
+        self.assertEqual(len(self.handler._buffer), 4)
 
         self.logger.test_status("test1", "sub8", status="FAIL")
         # The number of messages deleted comes back in a list.
-        self.assertEquals([4], self.logger.send_message("buffer", "flush"))
+        self.assertEqual([4], self.logger.send_message("buffer", "flush"))
 
         # When the buffer is dumped, the failure is the last thing logged
         self.assert_log_equals({"action": "test_status",
@@ -1025,7 +1026,7 @@ class TestReader(unittest.TestCase):
                 {"action": "action_1", "data": "data_1"}]
 
         f = self.to_file_like(data)
-        self.assertEquals(data, list(reader.read(f)))
+        self.assertEqual(data, list(reader.read(f)))
 
     def test_imap_log(self):
         data = [{"action": "action_0", "data": "data_0"},
@@ -1042,7 +1043,7 @@ class TestReader(unittest.TestCase):
         res_iter = reader.imap_log(reader.read(f),
                                    {"action_0": f_action_0,
                                     "action_1": f_action_1})
-        self.assertEquals([("action_0", "data_0"), ("action_1", "data_1")],
+        self.assertEqual([("action_0", "data_0"), ("action_1", "data_1")],
                           list(res_iter))
 
     def test_each_log(self):
@@ -1064,7 +1065,7 @@ class TestReader(unittest.TestCase):
                         {"action_0": f_action_0,
                          "action_1": f_action_1})
 
-        self.assertEquals({"action_0": 1, "action_1": 2}, count)
+        self.assertEqual({"action_0": 1, "action_1": 2}, count)
 
     def test_handler(self):
         data = [{"action": "action_0", "data": "data_0"},
@@ -1091,8 +1092,8 @@ class TestReader(unittest.TestCase):
         handler = ReaderTestHandler()
         reader.handle_log(reader.read(f), handler)
 
-        self.assertEquals(handler.action_0_count, 1)
-        self.assertEquals(handler.action_1_count, 1)
+        self.assertEqual(handler.action_0_count, 1)
+        self.assertEqual(handler.action_1_count, 1)
 
 if __name__ == "__main__":
     unittest.main()
diff --git a/testing/mozbase/moznetwork/moznetwork/__init__.py b/testing/mozbase/moznetwork/moznetwork/__init__.py
index df2097cb02..e3423e71ac 100644
--- a/testing/mozbase/moznetwork/moznetwork/__init__.py
+++ b/testing/mozbase/moznetwork/moznetwork/__init__.py
@@ -14,13 +14,13 @@ Example usage:
 
   try:
       ip = moznetwork.get_ip()
-      print "The external IP of your machine is '%s'" % ip
+      print("The external IP of your machine is '%s'" % ip)
   except moznetwork.NetworkError:
-      print "Unable to determine IP address of machine"
+      print("Unable to determine IP address of machine")
       raise
 
 """
 
-from moznetwork import get_ip
+from .moznetwork import get_ip
 
 __all__ = ['get_ip']
diff --git a/testing/mozbase/moznetwork/moznetwork/moznetwork.py b/testing/mozbase/moznetwork/moznetwork/moznetwork.py
index 5376496039..03b9cf15c3 100644
--- a/testing/mozbase/moznetwork/moznetwork/moznetwork.py
+++ b/testing/mozbase/moznetwork/moznetwork/moznetwork.py
@@ -51,7 +51,7 @@ def _get_interface_list():
                  socket.inet_ntoa(namestr[i + 20:i + 24]))
                 for i in range(0, outbytes, struct_size)]
 
-    except IOError:
+    except OSError:
         raise NetworkError('Unable to call ioctl with SIOCGIFCONF')
 
 
@@ -72,13 +72,13 @@ def _parse_ifconfig():
 
     # Attempt to determine the default interface in use.
     default_iface = _proc_matches(['route', '-n', 'get', 'default'],
-                                  'interface: (\w+)')
+                                  r'interface: (\w+)')
 
     if default_iface:
         addr_list = _proc_matches(['ifconfig', default_iface[0]],
-                                  'inet (\d+.\d+.\d+.\d+)')
+                                  r'inet (\d+.\d+.\d+.\d+)')
         if addr_list:
-            logger.debug('Default interface: [%s] %s' % (default_iface[0],
+            logger.debug('Default interface: [{}] {}'.format(default_iface[0],
                                                          addr_list[0]))
             if not addr_list[0].startswith('127.'):
                 return addr_list[0]
@@ -86,16 +86,16 @@ def _parse_ifconfig():
     # Iterate over plausible interfaces if we didn't find a suitable default.
     for iface in ['en%s' % i for i in range(10)]:
         addr_list = _proc_matches(['ifconfig', iface],
-                                  'inet (\d+.\d+.\d+.\d+)')
+                                  r'inet (\d+.\d+.\d+.\d+)')
         if addr_list:
-            logger.debug('Interface: [%s] %s' % (iface, addr_list[0]))
+            logger.debug('Interface: [{}] {}'.format(iface, addr_list[0]))
             if not addr_list[0].startswith('127.'):
                 return addr_list[0]
 
     # Just return any that isn't localhost. If we can't find one, we have
     # failed.
     addrs = _proc_matches(['ifconfig'],
-                          'inet (\d+.\d+.\d+.\d+)')
+                          r'inet (\d+.\d+.\d+.\d+)')
     try:
         return [addr for addr in addrs if not addr.startswith('127.')][0]
     except IndexError:
@@ -134,7 +134,7 @@ def get_ip():
         if mozinfo.isLinux:
             interfaces = _get_interface_list()
             for ifconfig in interfaces:
-                logger.debug('Interface: [%s] %s' % (ifconfig[0], ifconfig[1]))
+                logger.debug('Interface: [{}] {}'.format(ifconfig[0], ifconfig[1]))
                 if ifconfig[0] == 'lo':
                     continue
                 else:
diff --git a/testing/mozbase/moznetwork/tests/test.py b/testing/mozbase/moznetwork/tests/test.py
index 79eee6b038..e026010feb 100644
--- a/testing/mozbase/moznetwork/tests/test.py
+++ b/testing/mozbase/moznetwork/tests/test.py
@@ -4,7 +4,7 @@ Unit-Tests for moznetwork
 """
 
 import os
-import mock
+from unittest import mock
 import mozinfo
 import moznetwork
 import re
@@ -26,8 +26,8 @@ def verify_ip_in_list(ip):
 
     # Regex to match IPv4 addresses.
     # 0-255.0-255.0-255.0-255, note order is important here.
-    regexip = re.compile("((25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)\.){3}"
-                         "(25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)")
+    regexip = re.compile(r"((25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)\.){3}"
+                         r"(25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)")
 
     if mozinfo.isLinux or mozinfo.isMac or mozinfo.isBsd:
         # if "/sbin/ifconfig" exist, use it because it may not be in the
diff --git a/testing/mozbase/mozprocess/mozprocess/__init__.py b/testing/mozbase/mozprocess/mozprocess/__init__.py
index 0b238c2b25..fadb464639 100644
--- a/testing/mozbase/mozprocess/mozprocess/__init__.py
+++ b/testing/mozbase/mozprocess/mozprocess/__init__.py
@@ -3,6 +3,5 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 from .processhandler import *
diff --git a/testing/mozbase/mozprocess/mozprocess/processhandler.py b/testing/mozbase/mozprocess/mozprocess/processhandler.py
index 661a7820e2..e80b59ac1e 100644
--- a/testing/mozbase/mozprocess/mozprocess/processhandler.py
+++ b/testing/mozbase/mozprocess/mozprocess/processhandler.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import signal
@@ -11,7 +10,7 @@ import sys
 import threading
 import time
 import traceback
-from Queue import Queue, Empty
+from queue import Queue, Empty
 from datetime import datetime
 
 __all__ = ['ProcessHandlerMixin', 'ProcessHandler', 'LogOutput',
@@ -112,7 +111,7 @@ class ProcessHandlerMixin(object):
                                           shell, cwd, env,
                                           universal_newlines, startupinfo, creationflags)
             except OSError:
-                print >> sys.stderr, args
+                print(args, file=sys.stderr)
                 raise
 
         def debug(self, msg):
@@ -121,14 +120,14 @@ class ProcessHandlerMixin(object):
             thread = threading.current_thread().name
             print("DBG::MOZPROC PID:{} ({}) | {}".format(self.pid, thread, msg))
 
-        def __del__(self, _maxint=sys.maxint):
+        def __del__(self, _maxint=sys.maxsize):
             if isWin:
                 handle = getattr(self, '_handle', None)
                 if handle:
                     if hasattr(self, '_internal_poll'):
                         self._internal_poll(_deadstate=_maxint)
                     else:
-                        self.poll(_deadstate=sys.maxint)
+                        self.poll(_deadstate=sys.maxsize)
                 if handle or self._job or self._io_port:
                     self._cleanup()
             else:
@@ -161,7 +160,7 @@ class ProcessHandlerMixin(object):
                             # application might already have been terminated itself. Any other
                             # error would indicate a problem in killing the process.
                             if getattr(e, "errno", None) != 3:
-                                print >> sys.stderr, "Could not terminate process: %s" % self.pid
+                                print("Could not terminate process: %s" % self.pid, file=sys.stderr)
                                 raise
                     else:
                         os.kill(pid, sig)
@@ -196,7 +195,7 @@ class ProcessHandlerMixin(object):
 
             return subprocess.Popen.poll(self)
 
-        def wait(self):
+        def wait(self, timeout=None):
             """ Popen.wait
                 Called to wait for a running process to shut down and return
                 its exit code
@@ -228,7 +227,7 @@ class ProcessHandlerMixin(object):
                      p2cread, p2cwrite,
                      c2pread, c2pwrite,
                      errread, errwrite) = args_tuple
-                if not isinstance(args, basestring):
+                if not isinstance(args, str):
                     args = subprocess.list2cmdline(args)
 
                 # Always or in the create new process group
@@ -256,8 +255,7 @@ class ProcessHandlerMixin(object):
                 if not (can_create_job or can_nest_jobs) and not self._ignore_children:
                     # We can't create job objects AND the user wanted us to
                     # Warn the user about this.
-                    print >> sys.stderr, \
-                        "ProcessManager UNABLE to use job objects to manage child processes"
+                    print("ProcessManager UNABLE to use job objects to manage child processes", file=sys.stderr)
 
                 # set process creation flags
                 creationflags |= winprocess.CREATE_SUSPENDED
@@ -267,7 +265,7 @@ class ProcessHandlerMixin(object):
                 if not (can_create_job or can_nest_jobs):
                     # Since we've warned, we just log info here to inform you
                     # of the consequence of setting ignore_children = True
-                    print "ProcessManager NOT managing child processes"
+                    print("ProcessManager NOT managing child processes")
 
                 # create the process
                 hp, ht, pid, tid = winprocess.CreateProcess(
@@ -340,10 +338,10 @@ class ProcessHandlerMixin(object):
                         # Spin up our thread for managing the IO Completion Port
                         self._procmgrthread = threading.Thread(target=self._procmgr)
                     except:
-                        print >> sys.stderr, """Exception trying to use job objects;
-falling back to not using job objects for managing child processes"""
+                        print("""Exception trying to use job objects;
+falling back to not using job objects for managing child processes""", file=sys.stderr)
                         tb = traceback.format_exc()
-                        print >> sys.stderr, tb
+                        print(tb, file=sys.stderr)
                         # Ensure no dangling handles left behind
                         self._cleanup_job_io_port()
                 else:
@@ -406,14 +404,10 @@ falling back to not using job objects for managing child processes"""
                         # don't want to mistake that situation for the situation of an unexpected
                         # parent abort (which is what we're looking for here).
                         if diff.seconds > self.MAX_IOCOMPLETION_PORT_NOTIFICATION_DELAY:
-                            print >> sys.stderr, \
-                                "WARNING | IO Completion Port failed to signal process shutdown"
-                            print >> sys.stderr, \
-                                "Parent process %s exited with children alive:" % self.pid
-                            print >> sys.stderr, \
-                                "PIDS: %s" % ', '.join([str(i) for i in self._spawned_procs])
-                            print >> sys.stderr, \
-                                "Attempting to kill them, but no guarantee of success"
+                            print("WARNING | IO Completion Port failed to signal process shutdown", file=sys.stderr)
+                            print("Parent process %s exited with children alive:" % self.pid, file=sys.stderr)
+                            print("PIDS: %s" % ', '.join([str(i) for i in self._spawned_procs]), file=sys.stderr)
+                            print("Attempting to kill them, but no guarantee of success", file=sys.stderr)
 
                             self.kill()
                             self._process_events.put({self.pid: 'FINISHED'})
@@ -424,16 +418,15 @@ falling back to not using job objects for managing child processes"""
                         errcode = winprocess.GetLastError()
                         if errcode == winprocess.ERROR_ABANDONED_WAIT_0:
                             # Then something has killed the port, break the loop
-                            print >> sys.stderr, "IO Completion Port unexpectedly closed"
+                            print("IO Completion Port unexpectedly closed", file=sys.stderr)
                             self._process_events.put({self.pid: 'FINISHED'})
                             break
                         elif errcode == winprocess.WAIT_TIMEOUT:
                             # Timeouts are expected, just keep on polling
                             continue
                         else:
-                            print >> sys.stderr, \
-                                "Error Code %s trying to query IO Completion Port, " \
-                                "exiting" % errcode
+                            print("Error Code %s trying to query IO Completion Port, "
+                                "exiting" % errcode, file=sys.stderr)
                             raise WinError(errcode)
                             break
 
@@ -480,7 +473,7 @@ falling back to not using job objects for managing child processes"""
                             self.debug("We got a message %s" % msgid.value)
                             pass
 
-            def _wait(self):
+            def _wait(self, timeout=None):
                 # First, check to see if the process is still running
                 if self._handle:
                     self.returncode = winprocess.GetExitCodeProcess(self._handle)
@@ -534,11 +527,11 @@ falling back to not using job objects for managing child processes"""
 
                     if rc == winprocess.WAIT_TIMEOUT:
                         # The process isn't dead, so kill it
-                        print "Timed out waiting for process to close, attempting TerminateProcess"
+                        print("Timed out waiting for process to close, attempting TerminateProcess")
                         self.kill()
                     elif rc == winprocess.WAIT_OBJECT_0:
                         # We caught WAIT_OBJECT_0, which indicates all is well
-                        print "Single process terminated successfully"
+                        print("Single process terminated successfully")
                         self.returncode = winprocess.GetExitCodeProcess(self._handle)
                     else:
                         # An error occured we should probably throw
@@ -589,7 +582,7 @@ falling back to not using job objects for managing child processes"""
 
         elif isPosix:
 
-            def _wait(self):
+            def _wait(self, timeout=None):
                 """ Haven't found any reason to differentiate between these platforms
                     so they all use the same wait callback.  If it is necessary to
                     craft different styles of wait, then a new _wait method
@@ -616,15 +609,23 @@ falling back to not using job objects for managing child processes"""
                         if getattr(e, "errno", None) != 10:
                             # Error 10 is "no child process", which could indicate normal
                             # close
-                            print >> sys.stderr, \
-                                "Encountered error waiting for pid to close: %s" % e
+                            print("Encountered error waiting for pid to close: %s" % e, file=sys.stderr)
                             raise
 
                         return self.returncode
 
                 else:
-                    # For non-group wait, call base class
-                    subprocess.Popen.wait(self)
+                    # For non-group wait, use os.waitpid directly to avoid
+                    # infinite recursion with Python 3.13's Popen.wait()
+                    if self.returncode is None:
+                        try:
+                            pid, sts = os.waitpid(self.pid, 0)
+                            if os.WIFSIGNALED(sts):
+                                self.returncode = -os.WTERMSIG(sts)
+                            elif os.WIFEXITED(sts):
+                                self.returncode = os.WEXITSTATUS(sts)
+                        except OSError:
+                            pass
                     return self.returncode
 
             def _cleanup(self):
@@ -632,11 +633,20 @@ falling back to not using job objects for managing child processes"""
 
         else:
             # An unrecognized platform, we will call the base class for everything
-            print >> sys.stderr, \
-                "Unrecognized platform, process groups may not be managed properly"
+            print("Unrecognized platform, process groups may not be managed properly", file=sys.stderr)
 
-            def _wait(self):
-                self.returncode = subprocess.Popen.wait(self)
+            def _wait(self, timeout=None):
+                # Use os.waitpid directly to avoid infinite recursion
+                # with Python 3.13's Popen.wait() which calls self._wait()
+                if self.returncode is None:
+                    try:
+                        pid, sts = os.waitpid(self.pid, 0)
+                        if os.WIFSIGNALED(sts):
+                            self.returncode = -os.WTERMSIG(sts)
+                        elif os.WIFEXITED(sts):
+                            self.returncode = os.WEXITSTATUS(sts)
+                    except OSError:
+                        pass
                 return self.returncode
 
             def _cleanup(self):
@@ -842,8 +852,8 @@ falling back to not using job objects for managing child processes"""
 
     # TODO Remove this method when consumers have been fixed
     def waitForFinish(self, timeout=None):
-        print >> sys.stderr, "MOZPROCESS WARNING: ProcessHandler.waitForFinish() is deprecated, " \
-                             "use ProcessHandler.wait() instead"
+        print("MOZPROCESS WARNING: ProcessHandler.waitForFinish() is deprecated, "
+            "use ProcessHandler.wait() instead", file=sys.stderr)
         return self.wait(timeout=timeout)
 
     @property
@@ -874,10 +884,9 @@ falling back to not using job objects for managing child processes"""
 
             if new_pgid and new_pgid != self.proc.pgid:
                 self.proc.detached_pid = new_pid
-                print >> sys.stdout, \
-                    'Child process with id "%s" has been marked as detached because it is no ' \
-                    'longer in the managed process group. Keeping reference to the process id ' \
-                    '"%s" which is the new child process.' % (self.pid, new_pid)
+                print('Child process with id "%s" has been marked as detached because it is no '
+                    'longer in the managed process group. Keeping reference to the process id '
+                    '"%s" which is the new child process.' % (self.pid, new_pid), file=sys.stdout)
 
 
 class CallableList(list):
@@ -966,14 +975,20 @@ class ProcessReader(object):
             else:
                 if output_timeout is not None:
                     output_timeout = now + self.output_timeout
-                callback(line.rstrip())
+                _l = line.rstrip()
+                if isinstance(_l, bytes):
+                    _l = _l.decode('utf-8', errors='replace')
+                callback(_l)
             if timeout is not None and now > timeout:
                 timed_out = True
                 break
         # process remaining lines to read
         while not queue.empty():
             line, callback = queue.get(False)
-            callback(line.rstrip())
+            _l = line.rstrip()
+            if isinstance(_l, bytes):
+                _l = _l.decode('utf-8', errors='replace')
+            callback(_l)
         if timed_out:
             self.timeout_callback()
         if stdout_reader:
